// AecMfcUSBDlg.h : header file
//

#if !defined(AFX_AECMFCUSBDLG_H__131660BF_CF53_427B_B5F9_FFD73D463CF6__INCLUDED_)
#define AFX_AECMFCUSBDLG_H__131660BF_CF53_427B_B5F9_FFD73D463CF6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// ----->
#include <winioctl.h>
#include "StrHex.h"
#include "AecUsbTCioctl.h"
//#include "AecUsbTCDeviceinterface.h"	// Has class GUID definition
#include "AecUsbOpen.h"

#define     USB_DEVICE_NAME     "AecUsb"	//BASE device Name - Hard coded in the DRIVER
//GUID m_ClassGuid = AecUsbTCDevice_CLASS_GUID;




// <-----
/////////////////////////////////////////////////////////////////////////////
// CAecMfcUSBDlg dialog

class CAecMfcUSBDlg : public CDialog
{
// Construction
public:
	CAecMfcUSBDlg(CWnd* pParent = NULL);	// standard constructor
	~CAecMfcUSBDlg();

// Dialog Data
	//{{AFX_DATA(CAecMfcUSBDlg)
	enum { IDD = IDD_AECMFCUSB_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAecMfcUSBDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CAecMfcUSBDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonQuickread();
	afx_msg void OnCheckIntenableL21();
	afx_msg void OnCheckIntenableCompare();
	afx_msg void OnCheckIntenableVideo();
	afx_msg void OnCheckIntenableReader();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButtonZerovid();
	virtual void OnOK();
	afx_msg void OnButtonR1Go();
	afx_msg void OnButtonR4Go();
	afx_msg void OnButtonW1Go();
	afx_msg void OnButtonW4Go();
	afx_msg void OnButtonCmdGo();
	afx_msg void OnCheckTimerstop();
	afx_msg void OnCheckSlowmo();
	afx_msg void OnButtonL21();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int m_IntUpdateCounter;
	BOOLEAN m_slowmo;
	BOOL m_dataset;
	BYTE m_cmp0D;
	BYTE m_cmp0C;
	BOOLEAN m_StopPolling;
	BYTE m_cmp2E;
	BYTE m_ByteDSelected;
	BYTE m_ByteDActive;
	UINT m_Dlg_Timer;
	char hhmmssff[12];
	BYTE m_cmpReb;
	ULONG m_cmpRub;
	ULONG m_cmpRtb;
	int m_vidcount;
	BYTE CheckForInt();
	BYTE SndCmd(BYTE cmd);
	void W4(ULONG addr, ULONG data4);
	void W1(ULONG addr, BYTE data1);
	ULONG R4(ULONG addr);
	BYTE R1(ULONG addr);
	BOOL DoReadWriteAction(ULONG act, ULONG port, PULONG pdata);
	int LtoStrTm(ULONG dw, char *chs);
	void UpdateStatus_N_Signals();
	void ProcessIntEventCode(int IntId);
	BOOL Poll_And_Process();
	HANDLE OpenByInterface(GUID* pClassGuid, DWORD instance, PDWORD pError);
	//GUID m_ClassGuid = AecUsbTCDevice_CLASS_GUID;		// Class GUID used to open device
	HANDLE m_hAecDevice;	// Handle to device opened in driver.
	CStrHex sh1;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AECMFCUSBDLG_H__131660BF_CF53_427B_B5F9_FFD73D463CF6__INCLUDED_)
