
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~	

//	String / Character translation class functions
// -----------------------------------------------
CStrHex::CStrHex()
{
	i = 0;
}
// -----------------------------------------------
//receive each string and check each character for a '0'-'F' value
// if character is "out of range" low set to '0', else 'F'
DWORD CStrHex::ToHex(char *Ath)
{
	i = strlen(Ath);
	if (i == 1)	//convert to hex BYTE
	{
		by[3] = 0;
		by[2] = 0;
		by[1] = 0;
		by[0] = CHex(*Ath);
		//return (VOID*)(&B);					
	}
	else if (i == 2)	//convert to hex BYTE
	{
		by[3] = 0;
		by[2] = 0;
		by[1] = 0;
		by[0] = ((CHex(*(Ath+0)) * 0x10) + (CHex(*(Ath+1))));
		//return (VOID*)(&B);					
	}
	else if (i == 3)	//convert to hex BYTE
	{
		by[3] = 0;
		by[2] = 0;
		by[1] = CHex(*(Ath + 0));
		by[0] = ((CHex(*(Ath+1)) * 0x10) + (CHex(*(Ath+2))));
		//return (VOID*)(&B);					
	}
	else if (i == 4)	//convert to hex BYTE
	{
		by[3] = 0;
		by[2] = 0;
		by[1] = ((CHex(*(Ath+0)) * 0x10) + (CHex(*(Ath+1))));
		by[0] = ((CHex(*(Ath+2)) * 0x10) + (CHex(*(Ath+3))));
		//return (VOID*)(&B);					
	}
	else if (i == 5) //assume that there are 8 'hex' chars only
	{
		by[3] = 0;
		by[2] = CHex(*Ath);
		by[1] = ((CHex(*(Ath+1)) * 0x10) + (CHex(*(Ath+2))));
		by[0] = ((CHex(*(Ath+3)) * 0x10) + (CHex(*(Ath+4))));
		//return (VOID*)(&B);					
	}
	else if (i == 6) //assume that there are 8 'hex' chars only
	{
		by[3] = 0;
		by[2] = ((CHex(*(Ath+0)) * 0x10) + (CHex(*(Ath+1))));
		by[1] = ((CHex(*(Ath+2)) * 0x10) + (CHex(*(Ath+3))));
		by[0] = ((CHex(*(Ath+4)) * 0x10) + (CHex(*(Ath+5))));
		//return (VOID*)(&B);					
	}
	else if (i == 7) //assume that there are 8 'hex' chars only
	{
		by[3] = CHex(*(Ath+0));
		by[2] = ((CHex(*(Ath+1)) * 0x10) + (CHex(*(Ath+2))));
		by[1] = ((CHex(*(Ath+3)) * 0x10) + (CHex(*(Ath+4))));
		by[0] = ((CHex(*(Ath+5)) * 0x10) + (CHex(*(Ath+6))));
		//return (VOID*)(&B);					
	}

	else if ((i >= 8) && (i < 11)) //assume that there are 8 'hex' chars only
	{
		by[3] = ((CHex(*(Ath+0)) * 0x10) + (CHex(*(Ath+1))));
		by[2] = ((CHex(*(Ath+2)) * 0x10) + (CHex(*(Ath+3))));
		by[1] = ((CHex(*(Ath+4)) * 0x10) + (CHex(*(Ath+5))));
		by[0] = ((CHex(*(Ath+6)) * 0x10) + (CHex(*(Ath+7))));
		//return (VOID*)(&B);					
	}
	else //if (i >=11 )	//work with first 8 'hex' characters 
	{				// ie: hh:mm:ss:ff ==> (DWORD)0xhhmmssff
		by[3] = ((CHex(*(Ath+0)) * 0x10) + (CHex(*(Ath+1))));
		by[2] = ((CHex(*(Ath+3)) * 0x10) + (CHex(*(Ath+4))));
		by[1] = ((CHex(*(Ath+6)) * 0x10) + (CHex(*(Ath+7))));
		by[0] = ((CHex(*(Ath+9)) * 0x10) + (CHex(*(Ath+10))));
		//return (VOID*)(&B);			
	}
	return (DWORD)((by[3] * 0x1000000) + (by[2] * 0x10000) + (by[1] * 0x100) + by[0]);
}
// -----------------------------------------------
BYTE CStrHex::CHex(char c)
{
	//if (c > 'F')
	c = toupper(c);
	if (c > 'F')
		return 0x0F;
	else if (c >= 'A')
		return (BYTE)((c - 0x41) + 10);	// 'A' = 0x41 ==> 0x0A = 10
	else if ((c >= '0') && (c <= '9'))
		return (BYTE)(c - 0x30);
	else return 0x00;
}
// -----------------------------------------------
DWORD CStrHex::IntBCD(int i)
{
	iw = (DWORD)i;
	for (j = 0; (((iw / 10) != 0) && (j < 8)); j++)
	{
		by[j] = (BYTE)(iw % 10);// save each decimal value of int in separate byte
		iw /= 10;				// drop 1's digit (Assignment Operator)
	}
	for (k = j; k != 0; k--);
	{
		dw = (dw * 0x10) + (DWORD)by[k - 1];	// mix bytes back into packed HEX DWORD

	}
	return dw;
}
// -----------------------------------------------
int CStrHex::TotalFrames(DWORD wDat, int frm)
{
	int i;
	for (i=0; i<8; i++)
	{
		by[i] = (BYTE)(wDat % 0x10);
		wDat /= 0x10;
	}
					//ff0 + ff10*10   + (ss1 + ss10*10)*frames
	return ( (int)( by[0] + (by[1] * 10) + ((by[2] + (by[3] * 10)) * frm)
		+ ((by[4] + (by[5]*10)) * frm * 60)	//mm * 60sec * frames/sec
		+ ((by[6] + (by[7]*10)) * frm * 3600)) ); //hh * 3600sec * frames/sec
}
// -----------------------------------------------
BYTE CStrHex::IntBcdByte(int iDat)
{
	return (((iDat / 10) * 16 ) + (iDat % 10));
}

// -----------------------------------------------
BYTE CStrHex::WordBCD(WORD wDat)
{
	return (((wDat / 10) * 16 ) + (wDat % 10));
}
// -----------------------------------------------
BYTE CStrHex::PackHex(char high, char low)
{
	return ((CHex(high) * 0x10) + CHex(low));
}
// -----------------------------------------------
// subtract the second packed BCD from the first. Return +- value as int
int CStrHex::FramesDiff(DWORD dw1, DWORD dw2, int frames)
{
	//int i1, i2; //i1 = TotalFrames(dw1, frames); //i2 = TotalFrames(dw2, frames);
	return 	( TotalFrames(dw1, frames) - TotalFrames(dw2, frames));
}
// -----------------------------------------------
char* CStrHex::BStr(BYTE bt, char *chs)
{
	wsprintf (chs,"%2.2X",bt);
	return chs;
}
// -----------------------------------------------
char* CStrHex::WStr(WORD wd, char *chs)
{
	wsprintf (chs,"%4.4X",wd);
	return chs;
}
// -----------------------------------------------
char* CStrHex::DWStr(DWORD dw, char *chs)
{
	wsprintf (chs,"%8.8X",dw);
	return chs;
}
// -----------------------------------------------
char* CStrHex::DWStrTm(DWORD dw, char *chs)
{
	wsprintf (chs,"%8.8X",dw);
	chs[11] = 0;	//EOL
	chs[10] = chs[7];
	chs[9] = chs[6];
	chs[8] = ':';
	chs[7] = chs[5];
	chs[6] = chs[4];
	chs[5] = ':';
	chs[4] = chs[3];
	chs[3] = chs[2];
	chs[2] = ':';
	return chs;
}

// -----------------------------------------------
char CStrHex::NibChar(BYTE bt)
{
	char c;
	switch (bt){
	case 0x00:
		c = '0';
		break;
	case 0x01:
		c = '1';
		break;
	case 0x02:
		c = '2';
		break;
	case 0x03:
		c = '3';
		break;
	case 0x04:
		c = '4';
		break;
	case 0x05:
		c = '5';
		break;
	case 0x06:
		c = '6';
		break;
	case 0x07:
		c = '7';
		break;
	case 0x08:
		c = '8';
		break;
	case 0x09:
		c = '9';
		break;
	case 0x0A:
		c = 'A';
		break;
	case 0x0B:
		c = 'B';
		break;
	case 0x0C:
		c = 'C';
		break;
	case 0x0D:
		c = 'D';
		break;
	case 0x0E:
		c = 'E';
		break;
	default:
		c = 'F';
		break;
	}
	return c;	
}
